Subroutine Allocate_atom_arrays(Atom)
  Use NLTE_Atom_structure
  Implicit None
  Type (NLTE_Atom) :: Atom
  Integer :: status
!
  Allocate (Atom%cm_1(Atom%NK),stat=status)
  Allocate (Atom%eV(Atom%NK),stat=status)
  Allocate (Atom%g(Atom%NK),stat=status)
  Allocate (Atom%lvl_label(Atom%NK),stat=status)
  Allocate (Atom%ion(Atom%NK),stat=status)
!
  Allocate (Atom%GA(Atom%NLIN),stat=status)
  Allocate (Atom%GW(Atom%NLIN),stat=status)
  Allocate (Atom%GQ(Atom%NLIN),stat=status)
!
  Allocate (Atom%A(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%i(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%j(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%NQ(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%Q0(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%QMAX(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%f(Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%Alamb(Atom%NLIN+Atom%NCNT),stat=status)
!
  Allocate (Atom%iFIX(Atom%NFIX),stat=status)
  Allocate (Atom%jFIX(Atom%NFIX),stat=status)
  Allocate (Atom%ITRad(Atom%NFIX),stat=status)
  Allocate (Atom%IPho(Atom%NFIX),stat=status)
  Allocate (Atom%A0(Atom%NFIX),stat=status)
  Allocate (Atom%TRad(Atom%NFIX),stat=status)
!
  Allocate (Atom%krad(Atom%NK,Atom%NK),stat=status)
  Allocate (Atom%B(Atom%NK,Atom%NK),stat=status)
  Allocate (Atom%FRQ(0:MaxNFreqs,Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%Q(MaxNFreqs,Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%WQ(MaxNFreqs,Atom%NLIN+Atom%NCNT),stat=status)
  Allocate (Atom%AlphaC(MaxNFreqs,Atom%NLIN+Atom%NCNT),stat=status)
!
  Return
!
End Subroutine Allocate_atom_arrays
