C  Natasha!  -----------------------------------------18.01.96

C   Here I send you the improved formal solver. Try to understand it
C  and ask me any questions about.

C   Javier

C  P.S. I send also a Voigt routine just in case you need it.
C
C++++++++++++++++++++++++++++++++++++++++++++++++++++08.03.96 IAC
C                           PARABO in is used SCRT1D    
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++Natasha

	FUNCTION PARABO(TRICK,k,DTM,DTP,S0,SM,SP)
C  Parabolic aproximation of S....analytical integration
C
	IMPLICIT REAL*8 (A-H,O-Z)
C
        IF(DTM.GE.TRICK) THEN

C Natasha:
C           If DTM is too large (near low boundary)
C If we want to avoid underflow in DEXP
C
                    IF(DTM.GE.80.0) THEN
                    EXU=DEXP(-80.0D0)
                    ELSE              
                  EXU=DEXP(-DTM)
                    ENDIF

	U0=1.-EXU
	U1=DTM-1.+EXU
	U2=DTM*DTM-2.*DTM+2.-2.*EXU
C
        ELSE
C
        D2=DTM*DTM
        D3=DTM*D2
        D4=DTM*D3
        U0=DTM-(D2/2.D0)
        U1=(D2/2.D0)-(D3/6.D0)
        U2=(D3/3.D0)-(D4/12.D0)
C
        END IF        
C
	CM=(U2-U1*(DTP+2.*DTM))/(DTM*(DTM+DTP))+U0
	C0=(U1*(DTM+DTP)-U2)/(DTM*DTP)
	CP=(U2-DTM*U1)/(DTP*(DTM+DTP))
C
	PARABO=CM*SM+C0*S0+CP*SP
C
C        if(k.eq.5) then
C        print *,'s0 sm sp'
C        print *,s0
C        print *,sm
C        print *,sp
C        print *,'co cm cp'
C        print *,c0
C        print *,cm
C        print *,cp
C        print *,'parabo=',parabo
C        end if
C
	RETURN
	END
